<?php
	/************************************************************
	 * 	Classe Jabber - Expresso										*
	 *  ------------------------------------------------------- *  
	 *  Com Autenticao no Servidor Jabber com Tls					*	
	 *  Rodrigo Souza - rodsouza@celepar.pr.gov.br					*
	 *  Alexandre Correia - alexandrecorreia@celepar.pr.gov.br  *
	 ************************************************************/

class Socket
{
	private $socket;
		
	protected final function open($pRemoteSocket, $pTimeOut = 1, $pBlockingMode = 0 )
	{
		if ( ($this->socket = stream_socket_client($pRemoteSocket, $errno, $errstr)) )
      {
         //$this->socket = stream_socket_client($pRemoteSocket, $errno, $errstr);//, 1, STREAM_CLIENT_CONNECT+STREAM_CLIENT_PERSISTENT);
         //stream_set_write_buffer($this->socket, 0);
         stream_set_blocking($this->socket, $pBlockingMode);
         stream_set_timeout($this->socket, 1);//$pTimeOut);
         return true;
      }

      return false;
	}

	protected final function close()
	{
		if ( $this->isConnected() )
			return fclose($this->socket);
		else
			return false;
	}

	protected final function read($pLine = false, $pEnding = false, $pLength = 4096)
   /*
    *
    * the jabber's documentation recommends to read
    * the packages of socket with size of 4096 (2^12) KB
    *
    ******************************************************
    *
    * a documentao do jabber recomenda ler
    * os pacotes do socket com tamanho de 4096 (2^12) KB
    *
    */
	{
		if ( !$this->isConnected() )
         return false;

      if ( !$pLine )
         return @stream_get_line($this->socket, $pLength);

      $retorno = NULL;
      do
      {
         $line = NULL;
         $line = @stream_get_line($this->socket, $pLength);
         if ( $line != NULL )
         {
            $retorno .= $line;
         }
      }
      while ( $line != NULL );

      return $retorno;
	}

	protected final function write($pData)
	{
		if ( $this->isConnected() )
			return fwrite($this->socket, $pData);
		else
			return false;
	}

	protected final function isConnected()
	{
		if(is_resource($this->socket))
			return true;
		else
			return false;	
	}
	
	protected final function returnSocket()
	{
		return $this->socket;	
	}

	protected function __destruct()
	{
			//fclose($this->resource);
	}
}
?>
